---
title: Third party libraries
prefix: Third Party
...

Gramex uses open source third party libraries that use one of these licenses:

- [PSF license][PSF] (Python Software Foundation)
- [MIT license][MIT]
- [BSD license][BSD]
- [LGPL license][LGPL]
- [Apache license][Apache]
- [ISC license][ISC]

## Languages

- [Python](https://www.python.org/): [PSF license][PSF]
  - [Anaconda](https://docs.anaconda.com/anaconda/) distribution: [BSD license][BSD]
- [node.js](https://github.com/nodejs/node/blob/master/LICENSE): [MIT license][MIT]

## Python libraries
<!-- Keep this in sync with setup.py -->

- [argh](https://pypi.python.org/pypi/argh/): [LGPL license][LGPL]
- [boto3](https://pypi.org/project/boto3/): [Apache license][Apache]
- [cachetools](https://pypi.python.org/pypi/cachetools/): [MIT license][MIT]
- [colorama](https://pypi.python.org/pypi/colorama/): [BSD license][BSD]
- [colorlog](https://pypi.python.org/pypi/colorlog/): [MIT license][MIT]
- [crontab](https://pypi.python.org/pypi/crontab/): [LGPL license][LGPL]
- [cssselect](https://pypi.python.org/pypi/cssselect/): [BSD license][BSD]
- [diskcache](https://pypi.python.org/pypi/diskcache/): [Apache license][Apache]
- [futures](https://pypi.python.org/pypi/futures/): [PSF license][PSF]
- [blaze](https://pypi.python.org/pypi/blaze/): [MIT license][MIT]
- [datashape](https://pypi.python.org/pypi/datashape/): [MIT license][MIT]
- [h5py](https://pypi.python.org/pypi/h5py/): [MIT license][MIT]
- [ipdb](https://pypi.python.org/pypi/ipdb/): [BSD license][BSD]
- [jmespath](https://pypi.org/project/jmespath/): [MIT license][MIT]
- [ldap3](https://pypi.python.org/pypi/ldap3/): [LGPL license][LGPL]
- [markdown](https://pypi.python.org/pypi/markdown/): [BSD license][BSD]
- [oauthlib](https://pypi.python.org/pypi/oauthlib/): [BSD license][BSD]
- [orderedattrdict](https://pypi.python.org/pypi/orderedattrdict/): [MIT license][MIT]
- [lxml](https://pypi.python.org/pypi/lxml/): [BSD license][BSD]
- [matplotlib](https://pypi.python.org/pypi/matplotlib/): [PSF license][PSF]
- [pandas](https://pypi.python.org/pypi/pandas/): [BSD license][BSD]
- [passlib](https://pypi.python.org/pypi/passlib/): [BSD license][BSD]
- [pathlib](https://pypi.python.org/pypi/pathlib/): [MIT license][MIT]
- [pathtools](https://pypi.python.org/pypi/pathtools/): [MIT license][MIT]
- [psycopg2](https://pypi.python.org/pypi/psycopg2/): [LGPL license][LGPL]
- [pymysql](https://pypi.python.org/pypi/pymysql/): [MIT license][MIT]
- [pytest](https://pypi.org/project/pytest/): [MIT license][MIT]
- [python-pptx](https://github.com/scanny/python-pptx/blob/master/LICENSE/): [MIT license][MIT]
- [pyyaml](https://pypi.python.org/pypi/pyyaml/): [MIT license][MIT]
- [redis](https://pypi.org/project/redis/): [MIT license][MIT]
- [seaborn](https://pypi.org/project/seaborn/): [BSD license][BSD]
- [selenium](https://pypi.org/project/selenium/): [Apache license][Apache]
- [setuptools](https://pypi.python.org/pypi/setuptools/): [MIT license][MIT]
- [shutilwhich](https://pypi.python.org/pypi/shutilwhich/): [PSF license][PSF]
- [six](https://pypi.python.org/pypi/six/): [MIT license][MIT]
- [sqlalchemy](https://pypi.org/project/SQLAlchemy/): [MIT license][MIT]
- [sqlitedict](https://pypi.org/project/sqlitedict/): [Apache license][Apache]
- [textblob](https://pypi.python.org/pypi/textblob/): [MIT license][MIT]
- [tornado](https://pypi.python.org/pypi/tornado/): [Apache license][Apache]
- [watchdog](https://pypi.python.org/pypi/watchdog/): [Apache license][Apache]
- [xmljson](https://pypi.python.org/pypi/xmljson/): [MIT license][MIT]

## JavaScript libraries
<!-- find gramex -name package.json | grep -v node_modules | xargs jq '.dependencies, .devDependencies' -->

- [asciinema-player](https://www.npmjs.com/package/asciinema-player): [Apache license][Apache]
- [body-parser](https://www.npmjs.com/package/body-parser): [MIT license][MIT]
- [bootstrap-select-dropdown](https://www.npmjs.com/package/bootstrap-select-dropdown): [ISC license][ISC]
- [bootstrap-select](https://www.npmjs.com/package/bootstrap-select): [MIT license][MIT]
- [bootstrap](https://www.npmjs.com/package/bootstrap): [MIT license][MIT]
- [clipboard](https://www.npmjs.com/package/clipboard): [MIT license][MIT]
- [cookie](https://www.npmjs.com/package/cookie): [MIT license][MIT]
- [d3-scale-chromatic](https://www.npmjs.com/package/d3-scale-chromatic): [BSD license][BSD]
- [d3](https://www.npmjs.com/package/d3): [BSD license][BSD]
- [datarangepicker](https://www.npmjs.com/package/daterangepicker): [MIT license][MIT]
- [dropzone](https://www.npmjs.com/package/dropzone): [MIT license][MIT]
- [express](https://www.npmjs.com/package/express): [MIT license][MIT]
- [fast-image-size](https://www.npmjs.com/package/fast-image-size): [MIT license][MIT]
- [font-awesome](https://www.npmjs.com/package/font-awesome): [MIT license][MIT]
- [g1](https://www.npmjs.com/package/g1): [MIT license][MIT]
- [glob](https://www.npmjs.com/package/glob): [ISC license][ISC]
- [jquery](https://www.npmjs.com/package/jquery): [MIT license][MIT]
- [jsoneditor](https://www.npmjs.com/package/jsoneditor): [Apache license][Apache]
- [leaflet](https://www.npmjs.com/package/leaflet): [BSD license][BSD]
- [lodash](https://www.npmjs.com/package/lodash): [MIT license][MIT]
- [lunr](https://www.npmjs.com/package/lunr): [MIT license][MIT]
- [marked](https://www.npmjs.com/package/marked): [MIT license][MIT]
- [minimist](https://www.npmjs.com/package/minimist): [MIT license][MIT]
- [moment](https://www.npmjs.com/package/moment): [MIT license][MIT]
- [morphdom](https://www.npmjs.com/package/morphdom): [MIT license][MIT]
- [node-sass](https://www.npmjs.com/package/node-sass): [MIT license][MIT]
- [noty](https://www.npmjs.com/package/noty): [MIT license][MIT]
- [numeral](https://www.npmjs.com/package/numeral): [MIT license][MIT]
- [officegen](https://www.npmjs.com/package/officegen): [MIT license][MIT]
- [popper](https://www.npmjs.com/package/popper.js): [MIT license][MIT]
- [prismjs](https://www.npmjs.com/package/prismjs): [MIT license][MIT]
- [puppeteer](https://www.npmjs.com/package/puppeteer): [Apache license][Apache]
- [select2](https://www.npmjs.com/package/select2): [MIT license][MIT]
- [tether-sheperd](https://www.npmjs.com/package/tether-shepherd): [MIT license][MIT]
- [tmp](https://www.npmjs.com/package/tmp): [MIT license][MIT]
- [topojson](https://www.npmjs.com/package/topojson): [BSD license][BSD]
- [uglify-js](https://www.npmjs.com/package/uglify-js): [BSD license][BSD]
- [url-search-params](https://www.npmjs.com/package/url-search-params): [MIT license][MIT]
- [vega-embed](https://www.npmjs.com/package/vega-embed): [BSD license][BSD]
- [vega-lite](https://www.npmjs.com/package/vega-lite): [BSD license][BSD]
- [vega](https://www.npmjs.com/package/vega): [BSD license][BSD]
- [vegam](https://www.npmjs.com/package/vegam): [MIT license][MIT]
- [vue](https://www.npmjs.com/package/vue): [MIT license][MIT]
- [which](https://www.npmjs.com/package/which): [ISC license][ISC]
- [ws](https://www.npmjs.com/package/ws): [MIT license][MIT]

[MIT]: https://opensource.org/licenses/MIT
[BSD]: https://opensource.org/licenses/BSD-3-Clause
[LGPL]: https://opensource.org/licenses/LGPL-3.0
[Apache]: https://opensource.org/licenses/Apache-2.0
[PSF]: https://opensource.org/licenses/Python-2.0
[ISC]: https://opensource.org/licenses/ISC
[Node]: https://github.com/nodejs/node/blob/master/LICENSE
